package com.xiaoniu.subsystem.business.controller;

import com.alibaba.nacos.common.utils.CollectionUtils;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.xiaoniu.common.core.result.R;
import com.xiaoniu.common.core.utils.BeanUtil;
import com.xiaoniu.common.core.utils.poi.ExcelUtil;
import com.xiaoniu.common.log.annotation.Log;
import com.xiaoniu.common.log.enums.BusinessType;
import com.xiaoniu.subsystem.business.domain.CheckBedroom;
import com.xiaoniu.subsystem.business.domain.Sign;
import com.xiaoniu.subsystem.business.domain.dto.CheckBedroomDTO;
import com.xiaoniu.subsystem.business.domain.dto.CheckBedroomPageDTO;
import com.xiaoniu.subsystem.business.domain.vo.CheckBedroomPageVO;
import com.xiaoniu.subsystem.business.service.ICheckBedroomService;
import com.xiaoniu.subsystem.system.domain.Unit;
import com.xiaoniu.subsystem.system.service.IUnitService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.validation.Valid;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import static com.xiaoniu.common.security.utils.SecurityUtils.getUnitId;
import static com.xiaoniu.common.security.utils.SecurityUtils.getUserId;

/**
 * <p>
 * 查寝表 前端控制器
 * </p>
 *
 * @author haoxuyang
 * @since 2024-12-23 05:36:11
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("/checkBedroom")
@Tag(name = "查寝表", description = "查寝")
public class CheckBedroomController {
    private final IUnitService unitService;
    private final ICheckBedroomService checkBedroomService;
    /**
     * 分页
     */
    @GetMapping("/page")
    @ApiOperationSupport(order = 2)
    @Operation(summary = "分页", description = "传入CheckBedroomPageDTO")
    public R<IPage<CheckBedroomPageVO>> page(@Validated  CheckBedroomPageDTO dto) {
        IPage<CheckBedroom> pages = checkBedroomService.page(new Page<>(dto.getPageNum(), dto.getPageSize()),
                new LambdaQueryWrapper<CheckBedroom>()
                        .orderByDesc(CheckBedroom::getCreateTime)
                        .eq(null != dto.getFlightId(), CheckBedroom::getFlightId,dto.getFlightId())
                        .eq(null != dto.getUserId(),CheckBedroom::getUserId,dto.getUserId())
                        .eq(null != dto.getCheckDate(), CheckBedroom::getCheckDate, dto.getCheckDate())
                        .eq(StringUtils.isNotBlank(dto.getStatus()),CheckBedroom::getStatus,dto.getStatus())
                        .eq(StringUtils.isNotBlank(dto.getYear()),CheckBedroom::getYear,dto.getYear()));

        IPage<CheckBedroomPageVO> copy = BeanUtil.copy(pages, CheckBedroomPageVO.class);
        return R.data(copy);
    }

    /**
     * 新增
     */
    @PostMapping("/save")
    @ApiOperationSupport(order = 4)
    @Operation(summary = "新增", description = "传入CheckBedroomDTO")
    public R save(@Valid @RequestBody CheckBedroomDTO dto) {
        Unit unit = unitService.getById(getUnitId());
        CheckBedroom copy = BeanUtil.copy(dto, CheckBedroom.class)
                .setCreateDept(unit.getUnitId())
                .setCreateUser(getUserId())
                .setCreateTime(new Date());
        List<CheckBedroom> one = checkBedroomService.list(new LambdaQueryWrapper<CheckBedroom>()
                .eq(CheckBedroom::getUserName,copy.getUserName())
                .eq(CheckBedroom::getCheckDate,copy.getCheckDate())
                .eq(CheckBedroom::getFlightId,copy.getFlightId())
        );
        if (CollectionUtils.isNotEmpty(one)) {
            return R.fail("查寝数据已存在");
        }
        return R.status(checkBedroomService.save(copy));
    }

    /**
     * 修改
     */
    @PostMapping("/update")
    @ApiOperationSupport(order = 5)
    @Operation(summary = "修改", description = "传入CheckBedroomDTO")
    public R update(@Valid @RequestBody CheckBedroomDTO dto) {
        CheckBedroom copy = BeanUtil.copy(dto, CheckBedroom.class)
                .setUpdateUser(getUserId())
                .setUpdateTime(new Date());
        return R.status(checkBedroomService.updateById(copy));
    }

    /**
     * 删除
     */
    @PostMapping("/remove")
    @ApiOperationSupport(order = 7)
    @Operation(summary = "删除", description = "传入ids")
    public R remove(@Parameter(description = "主键集合", required = true) @RequestParam String ids) {
        return R.status(checkBedroomService.removeByIds(Arrays.stream(ids.split(",")).toList()));
    }

    /**
     * 导出
     */
    @GetMapping("/export")
    @ApiOperationSupport(order = 3)
    @Log(title = "导出", businessType = BusinessType.EXPORT)
    @Operation(summary = "导出", description = "传入CheckBedroomPageDTO")
    public void export(HttpServletResponse response, @Validated  CheckBedroomPageDTO dto) {
        List<CheckBedroom> list = new ArrayList<>();
        if (StringUtils.isNotBlank(dto.getIds())) {
            list.addAll(checkBedroomService.list(new LambdaQueryWrapper<CheckBedroom>()
                    .orderByDesc(CheckBedroom::getCreateTime)
                    .in(StringUtils.isNotBlank(dto.getIds()), CheckBedroom::getCheckId,
                            Arrays.stream(dto.getIds().split(",")).toList())));
        } else {
            list.addAll(checkBedroomService.list(new LambdaQueryWrapper<CheckBedroom>()
                    .orderByDesc(CheckBedroom::getCreateTime)
                    .eq(null != dto.getFlightId(), CheckBedroom::getFlightId,dto.getFlightId())
                    .eq(null != dto.getUserId(),CheckBedroom::getUserId,dto.getUserId())
                    .eq(null != dto.getCheckDate(), CheckBedroom::getCheckDate, dto.getCheckDate())
                    .eq(StringUtils.isNotBlank(dto.getStatus()), CheckBedroom::getStatus, dto.getStatus())
                    .eq(StringUtils.isNotBlank(dto.getYear()),CheckBedroom::getYear,dto.getYear())
            ));
        }
        ExcelUtil<CheckBedroom> excelUtil = new ExcelUtil<>(CheckBedroom.class);
        excelUtil.exportExcel(response, list, "教员信息统计数据");
    }

    /**
     * 导入
     */
    @PostMapping("/import")
    @ApiOperationSupport(order = 9)
    @Log(title = "查寝导入", businessType = BusinessType.IMPORT)
    @Operation(summary = "导入")
    public R importData(MultipartFile file,
                        @Parameter(description = "是否支持更新", required = true)
                        @RequestParam boolean updateSupport) throws Exception {
        ExcelUtil<CheckBedroom> util = new ExcelUtil<>(CheckBedroom.class);
        List<CheckBedroom> list = util.importExcel(file.getInputStream());
        return R.success(checkBedroomService.importData(list, updateSupport));
    }

    /**
     * 模版导入
     */
    @GetMapping("/importTemplate")
    @ApiOperationSupport(order = 10)
    @Operation(summary = "导入模版下载")
    public void importTemplate(HttpServletResponse response) {
        ExcelUtil<CheckBedroom> util = new ExcelUtil<>(CheckBedroom.class);
        util.importTemplateExcel(response, "查寝导入模版");
    }




}
